package com.xkrs.service.impl;

import com.xkrs.dao.QcInspectionItemDictDao;
import com.xkrs.dao.QcInspectionSpecDao;
import com.xkrs.encapsulation.PromptMessageEnum;
import com.xkrs.model.entity.QcInspectionItemDict;
import com.xkrs.model.entity.QcInspectionSpec;
import com.xkrs.model.qo.QcInspectionSpecQo;
import com.xkrs.service.QcInspectionSpecService;
import org.springframework.context.i18n.LocaleContextHolder;

import javax.annotation.Resource;
import java.util.Locale;

import static com.xkrs.encapsulation.OutputEncapsulation.outputEncapsulationObject;

public class QcInspectionSpecServiceImpl implements QcInspectionSpecService {

    @Resource
    private QcInspectionSpecDao inspectionSpecDao;

    @Resource
    private QcInspectionItemDictDao inspectionItemDictDao;


    /**
     * 新增规格数据
     *
     * @param inspectionSpecQo
     * @return
     */
    @Override
    public String insertSpec(QcInspectionSpecQo inspectionSpecQo) {
        String partNo = inspectionSpecQo.getPartNo();
        String inspectionItemCode = inspectionSpecQo.getInspectionItemCode();
        String max = inspectionSpecQo.getMax();
        String mean = inspectionSpecQo.getMean();
        String min = inspectionSpecQo.getMin();
        String unit = inspectionSpecQo.getUnit();
        String inspectionMethod = inspectionSpecQo.getInspectionMethod();
        String inspectionStandard = inspectionSpecQo.getInspectionStandard();
        String remark = inspectionSpecQo.getRemark();
        Locale locale = LocaleContextHolder.getLocale();
        QcInspectionItemDict byInspectionItemCode = inspectionItemDictDao.findByInspectionItemCode(inspectionSpecQo.getInspectionItemCode());
        if (byInspectionItemCode == null) {
            return outputEncapsulationObject(PromptMessageEnum.DATA_NONE, "不存在该字典类型！", locale);
        }
        QcInspectionSpec inspectionSpec = new QcInspectionSpec();
        if (inspectionSpecQo.getId() > 0) {
            inspectionSpec.setId(inspectionSpecQo.getId());
        }
        inspectionSpec.setPartNo(partNo);
        inspectionSpec.setInspectionItemCode(inspectionItemCode);
        inspectionSpec.setMax(max);
        inspectionSpec.setMean(mean);
        inspectionSpec.setMin(min);
        inspectionSpec.setUnit(unit);
        inspectionSpec.setInspectionMethod(inspectionMethod);
        inspectionSpec.setInspectionStandard(inspectionStandard);
        inspectionSpec.setRemark(remark);
        inspectionSpecDao.save(inspectionSpec);
        return outputEncapsulationObject(PromptMessageEnum.SUCCESS, "添加成功！", locale);
    }
}
